"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var parcel_extractor_1 = __importDefault(require("./parcel/parcel-extractor"));
var webpack_extractor_1 = __importDefault(require("./webpack/webpack-extractor"));
var extractor_1 = __importDefault(require("./script/extractor"));
exports.allExtractors = {
    "parcel": parcel_extractor_1.default,
    // "parcel-v1": parcelExtractor,  // alias
    // "parcel-v2": parcelV2Extractor,  // parcel v2 is unreleased
    "webpack": webpack_extractor_1.default,
    "webpack-jsonp": webpack_extractor_1.default,
    "none": extractor_1.default,
};
exports.extractor = function (ast, options) {
    // options = normalizeOptions(options)  // some extractors need to edit the options
    var singleExtractor = exports.allExtractors[options.type];
    return singleExtractor(ast, options);
};
exports.default = exports.extractor;
