"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var url_1 = require("url");
var path_1 = require("path");
var is_relative_module_path_1 = __importDefault(require("../../utils/is-relative-module-path"));
var normalizeModulePath = function (path, outputExt) {
    if (outputExt === void 0) { outputExt = "js"; }
    var p = path.match(/^file:\/\/(?:\.+\/)?(.+)/)[1];
    var e = path_1.extname(p);
    if (!e || !(e == ".js" || e == ".json" || e == ".jsx" || e == ".ts" || e == ".tsx")) {
        p += "." + outputExt; // ".js"
    }
    return p;
};
exports.solveModules = function (parcelExtracted, options) {
    var entryId = parcelExtracted.entry, modulesMap = parcelExtracted.modulesMap;
    var pathsMap = new Map();
    var solveRelativeRequires = function (selfId, selfPath) {
        if (pathsMap.has(selfId)) {
            return;
        }
        pathsMap.set(selfId, selfPath);
        var requiresMap = modulesMap.get(selfId).requires;
        Object.entries(requiresMap).forEach(function (_a) {
            var _b = __read(_a, 2), p = _b[0], id = _b[1];
            // don't solve node_modules
            if (!is_relative_module_path_1.default(p)) {
                return;
            }
            var moduleP = new url_1.URL(p, selfPath).href;
            // recursive solving
            solveRelativeRequires(id, moduleP);
        });
    };
    solveRelativeRequires(entryId, "file://./entry");
    // if (pathsMap.size != parcelExtracted.modulesMap.size) {
    //     throw new Error("something goes wrong")
    // }
    var ext = options.outputFileType == "typescript" ? "ts" : "js";
    var modules = {};
    pathsMap.forEach(function (modulePath, id) {
        var p = normalizeModulePath(modulePath, ext);
        modules[p] = modulesMap.get(id);
    });
    return {
        modules: modules,
        entry: entryId,
        entryPath: "entry." + ext
    };
};
exports.default = exports.solveModules;
