"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var extract_modules_1 = require("./extract-modules");
var transformer_1 = require("./transformer");
exports.webpackExtractor = function (ast, options) {
    var extractResult = extract_modules_1.extractModules(ast, options);
    if (options.replaceModuleFunctionParams) {
        // add webpack specific transformer
        if (!options.extraTransformers || !Array.isArray(options.extraTransformers)) {
            options.extraTransformers = [];
        }
        // Transform variables defined in ModuleFunction params to their real values
        var entry = extractResult.entry;
        var transformer = transformer_1.getModuleFunctionParamsTransformer(entry);
        options.extraTransformers.push(transformer);
    }
    return extractResult;
};
exports.default = exports.webpackExtractor;
