"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var printer_1 = require("./printer");
var defaultOptions = {
    lineTerminator: "\n",
    quote: "double",
    trailingComma: {
        objects: true,
        arrays: false,
        parameters: false,
    },
    arrowParensAlways: true,
};
exports.prettyPrint = function (ast, options) {
    options = Object.assign({}, defaultOptions, options || {});
    if (Array.isArray(ast)) {
        var sep = options.lineTerminator.repeat(2); // \n\n
        return new printer_1.PrintResult(ast.map(function (n) {
            return exports.prettyPrint(n, options).code;
        }).join(sep));
    }
    return new printer_1.Printer(options).printGenerically(ast);
};
/** @alias prettyPrint */
exports.generator = exports.prettyPrint;
exports.default = exports.generator;
