import { Options } from "./options";
import * as types from "ast-types";
export interface PrintResultType {
    code: string;
    map?: object;
    toString(): string;
}
export declare class PrintResult implements PrintResultType {
    code: string;
    map?: object;
    warnedAboutToString: boolean;
    constructor(code: string, sourceMap?: object);
    toString(): string;
}
export declare class Printer {
    config?: Options;
    explicitTabWidth?: number;
    constructor(config?: Options);
    printGenerically(ast: types.ASTNode): PrintResultType;
    private _makePrintFunctionWith;
    private _print;
}
