"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var visitor_wrapper_1 = __importDefault(require("../utils/visitor-wrapper"));
var types_1 = require("@babel/types");
/**
 * `void 0` -> `undefined`
 * @see https://babeljs.io/docs/en/babel-plugin-transform-undefined-to-void (reversed)
 */
exports.transformVoidToUndefined = visitor_wrapper_1.default({
    UnaryExpression: function (path) {
        var node = path.node;
        if (node.operator == "void" && types_1.isNumericLiteral(node.argument)) {
            var n = node.argument;
            if (n.value == 0) {
                path.replaceWith(types_1.identifier("undefined"));
            }
        }
    },
});
exports.default = exports.transformVoidToUndefined;
