"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var unminify_numeric_literals_1 = __importDefault(require("./unminify-numeric-literals"));
var unminify_booleans_1 = __importDefault(require("./unminify-booleans"));
var transform_void_to_undefined_1 = __importDefault(require("./transform-void-to-undefined"));
var unminify_infinity_1 = __importDefault(require("./unminify-infinity"));
var flip_comparisons_again_1 = __importDefault(require("./flip-comparisons-again"));
var unminify_variable_declarations_1 = __importDefault(require("./unminify-variable-declarations"));
var add_curly_braces_1 = __importDefault(require("./add-curly-braces"));
var add_parentheses_for_binary_expressions_1 = __importDefault(require("./add-parentheses-for-binary-expressions"));
var unminify_return_statements_1 = __importDefault(require("./unminify-return-statements"));
var unminify_return_void_1 = __importDefault(require("./unminify-return-void"));
var unminify_if_statements_1 = __importDefault(require("./unminify-if-statements"));
var unminify_sequence_expressions_1 = __importDefault(require("./unminify-sequence-expressions"));
var combine_transformers_1 = require("../utils/combine-transformers");
exports.allTransformers = {
    unminifyNumericLiterals: unminify_numeric_literals_1.default,
    unminifyBooleans: unminify_booleans_1.default,
    transformVoidToUndefined: transform_void_to_undefined_1.default,
    unminifyInfinity: unminify_infinity_1.default,
    flipComparisons: flip_comparisons_again_1.default,
    unminifyVariableDeclarations: unminify_variable_declarations_1.default,
    unminifyReturnStatement: unminify_return_statements_1.default,
    unminifyReturnVoid: unminify_return_void_1.default,
    unminifySequenceExpressions: unminify_sequence_expressions_1.default,
    unminifyIfStatements: unminify_if_statements_1.default,
    addCurlyBraces: add_curly_braces_1.default,
    addParenthesesForBinaryExpressions: add_parentheses_for_binary_expressions_1.default,
};
var defaultTransformOptions = {};
exports.transformAll = function (ast, options, extraTransformers) {
    options = Object.assign({}, defaultTransformOptions, options);
    var transformers = [];
    if (extraTransformers && Array.isArray(extraTransformers)) {
        if (!extraTransformers.every(function (f) { return typeof f == "function" && f.visitor; })) {
            throw new TypeError("some or all of the extraTransformers are not instances of Transformer");
        }
        transformers.push.apply(transformers, __spread(extraTransformers));
    }
    Object.entries(exports.allTransformers).map(function (_a) {
        var _b = __read(_a, 2), name = _b[0], fn = _b[1];
        if (!(options && typeof options !== "undefined" && options[name] === false)) { // ignore undefined
            transformers.push(fn);
        }
    });
    var combinedTransformer = combine_transformers_1.combineTransformers.apply(void 0, __spread(transformers));
    combinedTransformer(ast);
    return ast;
};
exports.default = exports.transformAll;
