"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var visitor_wrapper_1 = __importDefault(require("../utils/visitor-wrapper"));
var types_1 = require("@babel/types");
/**
 * `1 / 0` -> `Infinity`
 * @see https://babeljs.io/docs/en/babel-plugin-minify-infinity (reversed)
 */
exports.unminifyInfinity = visitor_wrapper_1.default({
    BinaryExpression: function (path) {
        var node = path.node;
        if (node.operator == "/" && types_1.isNumericLiteral(node.left) && types_1.isNumericLiteral(node.right)) {
            var left = node.left;
            var right = node.right;
            if (left.value === 1 && right.value === 0) {
                path.replaceWith(types_1.identifier("Infinity"));
            }
        }
    },
});
exports.default = exports.unminifyInfinity;
