"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var visitor_wrapper_1 = __importDefault(require("../utils/visitor-wrapper"));
var types_1 = require("@babel/types");
/**
 * `return a(), b()` -> `a(); return b()`
 */
exports.unminifyReturnStatement = visitor_wrapper_1.default({
    ReturnStatement: function (path) {
        var node = path.node;
        if (types_1.isSequenceExpression(node.argument)) {
            var expressions = node.argument.expressions;
            var realReturnE = expressions.pop();
            var siblings = expressions.map(function (e) {
                return types_1.expressionStatement(e);
            });
            path.replaceWithMultiple(__spread(siblings, [
                types_1.returnStatement(realReturnE),
            ]));
        }
    },
});
exports.default = exports.unminifyReturnStatement;
