import { TraverseOptions, VisitNodeObject, Visitor as BVisitor } from "@babel/traverse";
import { Node } from "@babel/types";
import { AST } from "./ast";
export { TraverseOptions };
export declare type StrictVisitor<S = Node> = Omit<BVisitor<S>, keyof VisitNodeObject<S, Node>>;
export declare type Visitor = TraverseOptions;
export interface Transformer {
    (ast: AST): void;
    visitor: TraverseOptions;
}
export declare const VisitorWrapper: (visitor: Visitor) => Transformer;
export default VisitorWrapper;
